#region usings
using System;
using VVVV.PluginInterfaces.V2;
using Newtonsoft.Json;

#endregion usings

namespace VVVV.Nodes
{
	#region PluginInfo
	[PluginInfo(Name = "AsString", Category = "Object", Version = "Json", Help = "Serializes objects to json strings", Author = "bjo:rn")]
	#endregion PluginInfo
	public class JsonObjectAsStringNode : IPluginEvaluate
	{
		#region fields & pins
		 [Input("Object")]
        public IDiffSpread<Object> Object;

        [Output("String")]
        public ISpread<string> _String;

		#endregion fields & pins

		//called when data for any output pin is requested
		public void Evaluate(int SpreadMax)
		{
			if (!Object.IsChanged) return;

            _String.SliceCount = SpreadMax;

            for (int i = 0; i < SpreadMax; i++)
            {
                var o = Object[i];
            	//_String[i] = o != null ? JsonConvert.SerializeObject(o, Formatting.Indented, new JsonSerializerSettings { TypeNameHandling = TypeNameHandling.None } ) : "";
            	_String[i] = o != null ? JsonConvert.SerializeObject(o, Formatting.Indented) : "";
            }
		}
	}
}
